%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% SET UP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% path to your results of one data set
path_input_method = '../example/chen_swa';

%%%% enable one of following paths
% path_ppm = 'dataset/SegTrack_ppm';
path_ppm = 'dataset/Chen_ppm';
% path_ppm = 'dataset/Gatech_ppm';

%%%% enable one of following
% dataset = 0; % SegTrack Data Set
dataset = 1; % Chen's Data Set
% dataset = 2; % Gatech Data Set

%%%% modify the place where you want to save the figures
output_path = '../example/chen_swa_benchmark';

%%%% show your method's performance on each video in the data set
% 1 --> on; 0 --> off
verbose = 1;

%%%% range of numbers of supervoxels generated by testing method
x_min = 200;
x_max = 900;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% DO NOT TOUCH BELOW
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath('code');
addpath('XuCorso_CVPR2012_mat');
mkdir(output_path);
if output_path(end) == '/'
    output_path = output_path(1:end-1);
end

matlabpool;

%%%% UE2D, UE3D, ACCU2D, ACCU3D, BR2D, BR3D
if dataset < 2
    test = TEST_Dataset(path_input_method, dataset, verbose, output_path);
    COMBINE_CURVE(test, dataset, x_min, x_max, output_path);
end

%%%% EV
test_ev = TEST_Dataset_EV(path_input_method, path_ppm, dataset, verbose, output_path);
COMBINE_CURVE_EV(test_ev, dataset, x_min, x_max, output_path);

%%%% length
test_length = TEST_length(path_input_method, dataset, verbose, output_path);
COMBINE_CURVE_LENGTH(test_length, dataset, x_min, x_max, output_path);

matlabpool close;
